[package]
authors = [
    "Ramsay Leung <ramsayleung@gmail.com>",
    "Mario Ortiz Manero <marioortizmanero@gmail.com>"
]
name = "rspotify-http"
version = "0.10.0"
license = "MIT"
readme = "README.md"
description = "HTTP compatibility layer for Rspotify"
homepage = "https://github.com/ramsayleung/rspotify"
repository = "https://github.com/ramsayleung/rspotify"
keywords = ["spotify", "api"]
edition = "2018"

[dependencies]
rspotify-model = { path = "../rspotify-model", version = "0.10.0" }

# Temporary until https://github.com/rust-lang/rfcs/issues/2739, for
# `maybe_async`.
async-trait = { version = "0.1.48", optional = true }
base64 = "0.13.0"
futures = { version = "0.3.8", optional = true }
log = "0.4.11"
maybe-async = "0.2.4"
reqwest = { version = "0.11.0", default-features = false, features = ["json", "socks"], optional = true }
serde_json = "1.0.57"
thiserror = "1.0.20"
ureq = { version = "2.0", default-features = false, features = ["json", "cookies"], optional = true }
url = "2.2.2"

[dev-dependencies]
env_logger = "0.8.1"
tokio = { version = "1.0", features = ["rt-multi-thread", "macros"] }

[features]
default = ["client-reqwest", "reqwest-default-tls"]

# Available clients. By default they don't include a TLS so that it can be
# configured.
client-ureq = ["ureq", "__sync"]
client-reqwest = ["reqwest", "__async"]

# Passing the TLS features to reqwest.
reqwest-default-tls = ["reqwest/default-tls"]
reqwest-rustls-tls = ["reqwest/rustls-tls"]
reqwest-native-tls = ["reqwest/native-tls"]
reqwest-native-tls-vendored = ["reqwest/native-tls-vendored"]
# Same for ureq.
ureq-rustls-tls = ["ureq/tls"]

# Internal features for checking async or sync compilation
__async = ["async-trait", "futures"]
__sync = ["maybe-async/is_sync"]
